use std::collections::HashMap;

use crate::tokeniser::tokentype::*;

use super::{expr::Expr, typ::Type, Ast};

#[derive(Debug, Clone)]
pub enum Literal {
    Number(Number),
    Ident(Ident),
    String(TString),
    Char(Char),
    Array(Vec<Expr>),
    ArrayRepeat {
        typ: Box<Type>,
        count: Box<Expr>,
    },
    Struct {
        name: Ident,
        fields: HashMap<Ident, Ast>
    },
}
