use std::collections::HashMap;

use typ::Type;

pub use crate::tokeniser::tokentype::*;

pub mod expr;
pub mod literal;
pub mod statement;
pub mod typ;

#[derive(Debug, Clone)]
pub struct Program {
    pub ast: expr::Block,
    pub structs: HashMap<Ident, HashMap<Ident, usize>>,
    pub enums: HashMap<Ident, usize>,
    pub types: HashMap<Type, Type>,
    pub functions: HashMap<Ident, (Vec<(Ident, Type)>, Type)>,
    pub member_functions: HashMap<Ident, HashMap<Ident, (Vec<(Ident, Type)>, Type)>>,
} 

#[derive(Debug, Clone)]
pub enum Ast {
    Expr(expr::Expr),
    Statement(statement::Statement),
}


